import numpy as np
import mk_gilli_templates as gt
import mk_gilli_distribution as gi
import string
import os
import sys
import make_bkgpatch
from multiprocessing import Pool

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Read configuration file
#lines = file(sys.argv[1]).readlines()
#lines = file("agnlist_patchTEST.cfg").readlines()
#lines = file("agnlist_PV.cfg").readlines()
lines = file("agnlist_XMMATLAS.cfg").readlines()
intlst=[]
floatlst=['RACEN','DECCEN','SQSIDE','RA1','RA2','DEC1','DEC2','FIXNH']
boollst = ['IMPOSENBR']
pparameters={}
for i in lines:
    if(i[0] == '#'):
        continue
    items = i.split(':')
    items = map(string.strip,items)
    items[1] = items[1].split('#')[0]
    items[1] = string.strip(items[1])
    if(items[0] == 'DIRTEMP'):
        if(not os.path.isdir(items[1])):
            print "ERROR: Directory DIRTEMP not found"
            sys.exit(1)
    if(items[0] in floatlst):
        try:
            items[1] = float(items[1])
        except:
            print "ERROR: the %s must be a float!" % items[0]
            sys.exit(1)
    if(items[0] in boollst):
        try:
            items[1] = items[1] in ['True','true','t','T']
        except:
            print "ERROR: the %s must be a True (true,t,T) anything else is False!" % items[0]
            sys.exit(1)
    pparameters[items[0]] = items[1]


#-----------------------------


geomtype = pparameters["GEOMTYPE"]
if(geomtype == 'projcircle'):
    myradius = np.sqrt(2*(pparameters["SQSIDE"]/2.)**2)
    geometry = [pparameters["RACEN"],pparameters["DECCEN"],myradius]
if(geomtype == 'angularbox'):
    geometry = [[pparameters["RA1"],pparameters["RA2"]],[pparameters["DEC1"],pparameters["DEC2"]]]


    
#gi.mk_attitude(master_attitude='oneyearsurvey_att.fits', area_def=geometry, geomtype=geomtype, output_attitude="output_attitude.fits")
#gi.gen_GRIDpositions(area_def=geometry,geomtype=geomtype, doffset=10./60.)

#make_bkgpatch.make_bkgpatch('toto_test.fits',area_def=geometry,area_type=geomtype,norm052=-1,dir='./BACKSPEC/',specfile='boller_newback_noagn.spec')


bankname="/local/age/CLERC/erositasimul-synthetic/Banks/PL_bank.fits"
dirtemp="/local/age/TMP"
gammamin=1.4
gammamax=2.4
ngammas=100
#gt.create_specbankPL(bankname,dirtemp,gammamin,gammamax,ngammas,npoints=2000)
#gt.read_specbankPL(bankname,phoindex=np.array([1.4,2.2]),z=np.array([0.1,0.5]),luminosity=np.array([1e44,1e44]),bandlum=[0.5,2.0])


CHOOSE=3
if(CHOOSE==1):
    paramDICT={'CHOOSE':CHOOSE, 'beta1':-1.58, 'beta2':-2.5, 'norm':1.51e16, 'lgf14_break':-0.04, 'lgf14_min':0, 'area':100.0,  'namepref':''}
if(CHOOSE==2):
    paramDICT={'CHOOSE':CHOOSE,'Nsources':100, 'namepref':'', 'flux':1e-12}
if(CHOOSE==3):
    paramDICT={'CHOOSE':CHOOSE,"fitsfile":"CATS/atlas-emlcat-v2.3-main.fits.gz", 'RAKEY':'ra', 'DECKEY':'dec', 'FLUXKEY':'flux052',  'namepref':''}
if(CHOOSE==4):
    paramDICT={'CHOOSE':CHOOSE,'doffset':10.0/60.0,  'namepref':'', 'flux':1e-13}

gi.sample_attitude(master_attitude="ATTITUDE/pv_all_attitude.fits", output_attitude="ATTITUDE/pv_all_attitude_10s.fits", sample_step=10)


#simput = "simput_AGNtest.fits"
#prefix = "AGNtest1"
#gi.age_realisation(simput, area_def=geometry,area_type=geomtype, paramDICT=paramDICT, specBank=[bankname], Gamma=1.4, band=[0.5,2.0])
#erosimLIST, caleventLIST = gi.age_sixterun(simput=simput, prefix=prefix, background='toto_test.fits', input_attitude="ATTITUDE/oneyearsurvey_att.fits", output_attitude='', area_def=geometry, area_type=geomtype, exposure=50e3)

# ATLAS
gi.age_realisation("simput_XMMATLAS_SOFT.fits", area_def=geometry,area_type=geomtype, paramDICT=paramDICT, specBank=[bankname], Gamma=1.4, band=[0.5,2.0])
erosimLIST, caleventLIST = gi.age_sixterun(simput='simput_XMMATLAS_SOFT.fits', prefix='XMMATLAS', background='toto_pv.fits', input_attitude="ATTITUDE/pv_all_attitude_10s.fits", output_attitude='xmmatlas_attitude.fits', area_def=geometry, area_type=geomtype, exposure=0.)

print erosimLIST
print caleventLIST
#if __name__ == '__main__':
#    p = Pool(8)
#    print(p.map(gi.call, erosimLIST))
#    p.close()
#    p = Pool(8)
#    print(p.map(gi.call, caleventLIST))
#    p.close()

#gi.age_sixterun(simput='simput_test.fits', prefix='AGNsurvey', background='toto_pv.fits', input_attitude="ATTITUDE/oneyearsurvey_att.fits", output_attitude='output_attitude.fits', area_def=geometry, area_type=geomtype, exposure=0.)

#gi.age_sixterun(simput='simput_test.fits', prefix='AGNsim', background='BACKSPEC/toto_t1.fits', input_attitude="ATTITUDE/oneyearsurvey_att.fits", output_attitude='', area_def=geometry, area_type=geomtype, exposure=50e3)


## I have to mk routines to read and crate attitide file
## I have to mk routines to execute sixte commands. 
